defmodule Eakins.UseCases.PreviewGravities do
  @moduledoc false

  alias Eakins.Image

  alias Eakins.UseCases.Reflection

  def call(schema_module, id, image_container, image_key, aspect_ratio)
      when is_binary(schema_module) do
    ("Elixir." <> schema_module)
    |> String.to_existing_atom()
    |> call(id, image_container, image_key, aspect_ratio)
  end

  def call(schema_module, id, image_container, image_key, aspect_ratio) do
    record = schema_module.record(id)
    image = Reflection.find_image(record, image_container, image_key)

    if image do
      for gravity <- Image.gravities() do
        Image.Display.new(%{image | gravity: gravity}, aspect_ratio, :large)
      end
    end
  end
end
