defmodule Eakins.UseCases.UpdateGravity do
  @moduledoc false

  alias Eakins.UseCases.Reflection
  alias Eakins.Repo

  def call(schema_module, id, image_container, image_key, gravity)
      when is_binary(schema_module) do
    ("Elixir." <> schema_module)
    |> String.to_existing_atom()
    |> call(id, image_container, image_key, gravity)
  end

  def call(schema_module, id, image_container, image_key, gravity) do
    record = schema_module.record(id)
    image = Reflection.find_image(record, image_container, image_key)
    changeset = schema_module.changeset(record, %{})

    record
    |> Reflection.update_image(image_container, changeset, %{image | gravity: gravity})
    |> Repo.update()
  end
end
